#!/usr/bin/perl
# cua-cw2-taskb.cgi

use CGI qw/:standard/;				# uses the standard Perl CGI commands, which includes HTML

$outdoc = new CGI;                   		# creates an instance of CGI, which I can use to create a HTML page

# assign the variables from input on the webform
$name = param('name');
$filename = param('filename');
# $filename = "../public_html/taskB/" . $file;    # create the filepath - not needed now

# open the file for reading and read into array.  Then close the file (for neatness).
open(FILE, "<$filename") or die "File not found";
@textfile=<FILE>;
close (FILE);

# print the header information, setting the doctype to XHTML strict (this would hopefully validate)
# the divs follow the same pattern as used on the main site, so the pages should look the same.
print $outdoc -> header(-type=>'text/html', -charset=>'UTF-8');
print $outdoc -> start_html(-title=>'Jo Carter -- Task B CGI', -style=>{-src=>'../style.css'}, -dtd=>'-//W3C//DTD XHTML 1.0 Strict//EN');
print $outdoc -> start_div();
print $outdoc -> div({-class=>'title'}, h1("Task B CGI Output"));

# print out the extra html to make the pages look the same, this would have been done in pure PERL except the a href
# causes problems when nested.
print <<html_body;
	<div class="top_menu">
		<ul>
			<li><a href="../index.html">Home</a></li>
			<li><a href="../taskA/taskA.html">Task A</a></li>
			<li><b><a href="taskB.html">Task B</a></b></li>
			<li><a href="../taskC/taskC.html">Task C</a></li>
		</ul>
	</div>
	
	<div class="bottom_menu">
		<ul>
			<li>&gt; <a href="http://www.jocarter.co.uk/">My Site</a></li>
			<li>&gt; <a href="http://www.livejournal.com/users/angelsk/">My LJ</a></li>
		</ul>
	</div>
	
	<div class="bottom">
    		<p><a href="http://validator.w3.org/check?uri=referer">
        	<img src="../images/xhtml11.png" alt="Valid Strict XHTML" height="15" width="80" /></a><br />
        	<a href="http://jigsaw.w3.org/css-validator/">
      		<img src="../images/css.png" width="80" height="15" alt="Valid CSS" /></a><br />
        	<img src="../images/anybrowser.png" width="80" height="15" alt="Any Browser" /><br />
        	<img src="../images/csstableless.gif" width="80" height="15" alt="CSS Tableless" /></p>
    		<ul>
    			<li>Jo Carter <sup>&copy;</sup> 2004</li>
    			<li><a href="mailto:portfolio\@jocarter.co.uk">Contact Me</a></li>
    		</ul>
	</div>
html_body

# print out the rest of the page content.
print $outdoc -> start_div({-class=>'content'});
print $outdoc -> h2("---Hi $name---");
print $outdoc -> start_p();
print "You entered the following filename: $file";
print br;
print "Your file is displayed below.";
print $outdoc -> end_p;

if ($file ne "")					# If a file was entered, display it
{
	print $outdoc -> h2("--$textfile[0]--");      	# print out the first line as a title
							# h2 fits in with the page style, although h1 was in the spec.
	print $outdoc -> start_p();

	# print out all the other lines of the file
	$length=@textfile;
	for ($counter=1; $counter<$length; $counter++)
	{
    		print "$textfile[$counter]";
    		print br;
	}

	print $outdoc -> end_p;
}
else							# if no file entered, display the message
{							# this catches the instance where nothing is entered, otherwise it
	print $outdoc -> p("No file was entered.");	# displays the folder contents.
}

print $outdoc -> end_div;
print $outdoc -> end_div;
print $outdoc -> end_html;				# end the divs, and the html page
