#!/usr/bin/perl
# cua-cw2-taskc.cgi

use CGI qw/:standard/;			# uses the standard Perl CGI commands, which includes HTML

$outdoc = new CGI;                   	# creates an instance of CGI, which I can use to create a HTML page

# assign the variables from input on the webform
$fname = param('fname');
$sname = param('sname');
$lname = param('lname');
$age = param('age');
$sex = param('sex');
$food = param('food');
@pastimes = param('pastime');

# create the file name and path.
$filename = "personal.csv";
# $filename = "../public_html/taskC/" . $file;  # not needed now

# open file and append current data to it, then close it (else the new data will not be displayed in the next part).
# open is supposed to close the file before it opens another, but as this is the same file I'm not taking any chances.
open(FILE, ">>$filename") or die "File not found";
print FILE "$fname,$sname,$lname,$age,$sex,$food";
foreach $pastimes_item(@pastimes)
{
    print FILE ",$pastimes_item";
}
print FILE "\n";			# new line, so that data entries do not run on.
close (FILE);

# open the file and read out all the lines of data into an array, then close the file (for neatness).
open (FILEREAD, "<$filename") or die "File not found";
@info = <FILEREAD>;
close (FILEREAD);

# print the header information, setting the doctype to XHTML strict (this would hopefully validate)
# the divs follow the same pattern as used on the main site, so the pages should look the same.
print $outdoc -> header(-type=>'text/html', -charset=>'UTF-8');
print $outdoc -> start_html(-title=>'Jo Carter -- Task C CGI', -style=>{-src=>'../style.css'}, -dtd=>'-//W3C//DTD XHTML 1.0 Strict//EN');
print $outdoc -> start_div();
print $outdoc -> div({-class=>'title'}, h1("Task C CGI Output"));

# print out the extra html to make the pages look the same, this would have been done in pure PERL except the a href
# causes problems when nested
print <<html_body;
	<div class="top_menu">
		<ul>
			<li><a href="../index.html">Home</a></li>
			<li><a href="../taskA/taskA.html">Task A</a></li>
			<li><a href="../taskB/taskB.html">Task B</a></li>
			<li><b><a href="taskC.html">Task C</a></b></li>
		</ul>
	</div>
	
	<div class="bottom_menu">
		<ul>
			<li>&gt; <a href="http://www.jocarter.co.uk/">My Site</a></li>
			<li>&gt; <a href="http://www.livejournal.com/users/angelsk/">My LJ</a></li>
		</ul>
	</div>
	
	<div class="bottom">
    		<p><a href="http://validator.w3.org/check?uri=referer">
        	<img src="../images/xhtml11.png" alt="Valid Strict XHTML" height="15" width="80" /></a><br />
        	<a href="http://jigsaw.w3.org/css-validator/">
      		<img src="../images/css.png" width="80" height="15" alt="Valid CSS" /></a><br />
        	<img src="../images/anybrowser.png" width="80" height="15" alt="Any Browser" /><br />
        	<img src="../images/csstableless.gif" width="80" height="15" alt="CSS Tableless" /></p>
    		<ul>
    			<li>Jo Carter <sup>&copy;</sup> 2004</li>
    			<li><a href="mailto:portfolio\@jocarter.co.uk">Contact Me</a></li>
    		</ul>
	</div>
html_body

print $outdoc -> start_div({-class=>'content'});
print $outdoc -> h2("---$file output---");

# split each item up, add to an array and then display in a table
foreach $info_item(@info)
{
    @personal = split(/,/, $info_item);

    # create each table row, with the header rows in a different colour.
    @rows = ("<tr class=\"emphasis\"><td><b>First Name:</b></td><td><b>$personal[0]</b></td><td>Second Name:</td><td>$personal[1]</td><td>Family Name:</td><td>$personal[2]</td></tr>",
             "<tr><td>Age:</td><td>$personal[3]</td><td>Gender:</td><td>$personal[4]</td><td>Favourite Food:</td><td>$personal[5]</td></tr>",
             "<tr class=\"emphasis\"><td>They enjoy:</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>");
    
    $td = "<tr>";				# the start of the row, to which the table cells are added below.
    $length = @personal;
    $number = 1;

    # for the rest of the array, the pastimes elements
    for ($counter=6; $counter<$length; $counter++)	
    {
        $td = $td . "<td>$number)</td><td>$personal[$counter]</td>";
        $number++;
        if ($counter == 8)
        {   
            $td = $td . "</tr>";		# end the row
            push(@rows,$td);            	# add the row to the array
            $td = "<tr>";			# start the next row
        }
    }

    # create the empty cells
    if (($length == 7) or ($length == 10))
    {
        $td = $td . "<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";
        push(@rows,$td);
    }
    if (($length == 8) or ($length == 11))
    {
        $td = $td . "<td>&nbsp;</td><td>&nbsp;</td></tr>";
        push(@rows,$td);
    }

    # if there are 3 or less pastimes, then push an empty row
    if ($length < 10)
    {
        $td = "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";        
	push(@rows,$td);
    }

    # print the table.  This would have been done in pure Perl with a similar method to above, except that pushing the
    # data into the array in the format needed to display rows in Perl used up too much memory.
    # it would have been easier to display the alternated coloured rows this way though, through the use of % (modulus).
    print "<table>";
    
    foreach $rows_item(@rows)
    {
    	print "$rows_item";
    }
    
    print "</table>";
    print $outdoc -> br;			# to separate the tables.
}

print $outdoc -> end_div;
print $outdoc -> end_div;
print $outdoc -> end_html;			# end the divs, and the html page
